/* $Id: captivemodid.h,v 1.4 2003/09/17 15:43:52 short Exp $
 * Include file for W32 disk modules identifier for acquiration installation utility
 * Copyright (C) 2003 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _CAPTIVE_INSTALL_ACQUIRE_CAPTIVEMODID_H
#define _CAPTIVE_INSTALL_ACQUIRE_CAPTIVEMODID_H 1


#include <glib/gtypes.h>
#include <libgnomevfs/gnome-vfs-file-size.h>
#include <libxml/tree.h>	/* for xmlChar */
#include <glib/ghash.h>


G_BEGIN_DECLS

struct captivemodid_module {
	const xmlChar *type;
	gint length;
	const xmlChar *md5;
	const xmlChar *id;
	gint priority;
	gint cabinet_used;
	};

extern void (*captivemodid_module_best_priority_notify)(const gchar *module_type);

gchar *calc_md5(gconstpointer base,size_t length);
gboolean captivemodid_module_length_is_valid(GnomeVFSFileSize file_size);
struct captivemodid_module *captivemodid_module_md5_lookup(const gchar *file_md5);
gint captivemodid_module_type_best_priority_lookup(const xmlChar *module_type);
gboolean captivemodid_module_type_best_priority_found(const xmlChar *module_type);
gboolean captivemodid_load(const gchar *captivemodid_pathname);
gint captivemodid_cabinet_length_to_used(gint cabinet_length);

G_END_DECLS


#endif /* _CAPTIVE_INSTALL_ACQUIRE_CAPTIVEMODID_H */
